// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from plotjuggler_msgs:msg/DataPoints.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "plotjuggler_msgs/msg/data_points.hpp"


#ifndef PLOTJUGGLER_MSGS__MSG__DETAIL__DATA_POINTS__TRAITS_HPP_
#define PLOTJUGGLER_MSGS__MSG__DETAIL__DATA_POINTS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "plotjuggler_msgs/msg/detail/data_points__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'samples'
#include "plotjuggler_msgs/msg/detail/data_point__traits.hpp"

namespace plotjuggler_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const DataPoints & msg,
  std::ostream & out)
{
  out << "{";
  // member: dictionary_uuid
  {
    out << "dictionary_uuid: ";
    rosidl_generator_traits::value_to_yaml(msg.dictionary_uuid, out);
    out << ", ";
  }

  // member: samples
  {
    if (msg.samples.size() == 0) {
      out << "samples: []";
    } else {
      out << "samples: [";
      size_t pending_items = msg.samples.size();
      for (auto item : msg.samples) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DataPoints & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: dictionary_uuid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dictionary_uuid: ";
    rosidl_generator_traits::value_to_yaml(msg.dictionary_uuid, out);
    out << "\n";
  }

  // member: samples
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.samples.size() == 0) {
      out << "samples: []\n";
    } else {
      out << "samples:\n";
      for (auto item : msg.samples) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DataPoints & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace plotjuggler_msgs

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<plotjuggler_msgs::msg::DataPoints>()
{
  return "plotjuggler_msgs::msg::DataPoints";
}

template<>
inline const char * name<plotjuggler_msgs::msg::DataPoints>()
{
  return "plotjuggler_msgs/msg/DataPoints";
}

template<>
struct has_fixed_size<plotjuggler_msgs::msg::DataPoints>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<plotjuggler_msgs::msg::DataPoints>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<plotjuggler_msgs::msg::DataPoints>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PLOTJUGGLER_MSGS__MSG__DETAIL__DATA_POINTS__TRAITS_HPP_
